<?php

function rvac_invalidate_cache()
{
  global $conf;
  conf_update_param('rvac_version', ++$conf['rvac_version'] );
  if (rand()%10==0)
  {
    foreach (glob(PHPWG_ROOT_PATH.PWG_COMBINED_DIR.'acds-*.js') as $file)
      @unlink($file);
  }
}

function rvac_custom_link(&$suggestion, $roots)
{
  $url = $suggestion['url'];
  if (empty($url))
  {
    $q = $suggestion['name'];
    if ( ($pos=strpos($q,'\\')) !== false )
    {
      $q = substr($q, 0, $pos);
    }
  }
  elseif (strncmp($url,'q=',2)==0)
  {
    $q = substr($url,2);
  }
  else
  {
    foreach( $roots as $k => $root)
      $url = str_replace('$'.$k.'/', $root, $url);
  }

  if (isset($q))
  {
    if ( ($pos=strpos($q,' ')) !== false )
    {
      $q = '"'.$q.'"';
    }
    $url = get_root_url().'qsearch.php?q='.rawurlencode($q);
  }

  $suggestion['U_LINK'] = $url;
  return $suggestion;
}

function rvac_ws_add_methods($srv_arr)
{
  $srv = $srv_arr[0];
  include_once( dirname(__FILE__).'/../functions.inc.php' );
  $srv->addMethod('rvac.addCustom', 'rv_ac_ws_add_custom_suggestion',
    array(
      'name' => array(),
      'counter' => array('default'=>0),
      'url' => array('default'=>''),
    ),
    '');

  $srv->addMethod('rvac.modCustom', 'rv_ac_ws_mod_custom_suggestion',
    array(
      'id' => array(),
      'name' => array('flags' => WS_PARAM_OPTIONAL),
      'counter' => array('flags' => WS_PARAM_OPTIONAL),
      'url' => array('flags' => WS_PARAM_OPTIONAL),
    ),
    '');

  $srv->addMethod('rvac.delCustom', 'rv_ac_ws_del_custom_suggestion',
    array('id'),
    '');
}

function rv_ac_ws_add_custom_suggestion($params, $service)
{
  global $conf;
  if (!is_admin() || !$service->isPost())
    return new PwgError(403, 'post admin');

  $name = trim($params['name']);
  if (empty($name))
    return new PwgError(400, 'Bad name');

  $insert = array('name'=>$name);

  if (isset($params['counter']))
    $insert['counter'] = intval($params['counter']);
  if ( !empty($params['url']) )
    $insert['url'] = $params['url'];

  mass_inserts(RVAC_SUGGESTIONS, array_keys($insert), array($insert));
  $id =  pwg_db_insert_id(RVAC_SUGGESTIONS);

  rvac_invalidate_cache();
  $row = pwg_db_fetch_assoc( pwg_query('SELECT * FROM '.RVAC_SUGGESTIONS.' WHERE id='.$id) );
  rvac_custom_link($row, rvac_get_url_roots());
  return $row;
}

function rv_ac_ws_mod_custom_suggestion($params, $service)
{
  global $conf;
  if (!is_admin() || !$service->isPost())
    return new PwgError(403, 'post admin');
  $id = intval($params['id']);
  $update = array();

  if (!empty($params['name']))
    $update['name'] = $params['name'];
  if (isset($params['counter']))
    $update['counter'] = intval($params['counter']);
  if (isset($params['url']))
    $update['url'] = $params['url'];

  single_update(RVAC_SUGGESTIONS,
    $update,
    array('id' => $id)
    );
  $changes = pwg_db_changes();

  if ($changes)
    rvac_invalidate_cache();

  $row = pwg_db_fetch_assoc( pwg_query('SELECT * FROM '.RVAC_SUGGESTIONS.' WHERE id='.$id) );
  rvac_custom_link($row, rvac_get_url_roots());
  return $row;
}

function rv_ac_ws_del_custom_suggestion($params, $service)
{
  global $conf;
  if (!is_admin() || !$service->isPost())
    return new PwgError(403, 'post admin');

  $id = intval($params['id']);
  $q = 'DELETE FROM '.RVAC_SUGGESTIONS.' WHERE id='.$id;
  pwg_query($q);
  $changes = pwg_db_changes();
  if ($changes)
    rvac_invalidate_cache();
  return $changes;
}

?>